using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;

namespace Strata.Code.DataAccess.Models;

[PrimaryKey("BudgetConfigId", "DepartmentId", "AccountId")]
[Table("BenefitsSpreads", Schema = "fp")]
public partial class BenefitsSpread
{
    [Key]
    [Column("BudgetConfigID")]
    public int BudgetConfigId { get; set; }

    [Key]
    [Column("DepartmentID")]
    public int DepartmentId { get; set; }

    [Key]
    [Column("AccountID")]
    public int AccountId { get; set; }

    public bool IsInactive { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage01 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage02 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage03 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage04 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage05 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage06 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage07 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage08 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage09 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage10 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage11 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage12 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? TotalImportedValue { get; set; }

    [Column("SpreadHistoryGUID")]
    public Guid SpreadHistoryGuid { get; set; }

    [Column("GlobalSpreadID")]
    public int GlobalSpreadId { get; set; }

    [ForeignKey("SpreadHistoryGuid")]
    [InverseProperty("BenefitsSpreads")]
    public virtual SpreadHistory SpreadHistory { get; set; } = null!;
}
